<?php

use application\core\model\Log;
use application\core\utils\Env;
use application\core\utils\Ibos;
use application\core\utils\File;
use application\core\utils\Module;
use application\core\utils\String;
use application\modules\workflow\utils\Common;

session_start();
error_reporting( E_ERROR | E_WARNING | E_PARSE );
date_default_timezone_set( 'PRC' );
@set_time_limit( 1000 );
ini_set( 'memory_limit', '100M' );
@set_magic_quotes_runtime( 0 );

define( 'PATH_ROOT', dirname( __FILE__ ) . '/../' );
$defines = PATH_ROOT . '/system/defines.php';
define( 'TIMESTAMP', time() );
define( 'YII_DEBUG', true );
define( 'IN_DEBUG', true );
$yii = PATH_ROOT . '/library/yii.php';
$mainConfig = require_once PATH_ROOT . '/system/config/common.php';
require_once ( $defines );
require_once ( $yii );
Yii::setPathOfAlias( 'application', PATH_ROOT . DIRECTORY_SEPARATOR . 'system' );
Yii::createApplication( 'application\core\components\Application', $mainConfig );

//======================================更新数据开始=========================================

$act = isset( $_GET['act'] ) ? $_GET['act'] : 'updateStructure';
$allowActs = array( 'updateStructure', 'updateData', 'updateSuccess' );
if ( !in_array( $act, $allowActs ) ) {
	$act = 'updateStructure';
}

$limit = 50;
$fileName = 'update.php';

if ( $act == 'updateStructure' ) { // 修改数据结构
	$sql_1 = "ALTER TABLE `{{role}}`
ADD COLUMN `roletype`  tinyint(1) UNSIGNED NOT NULL DEFAULT 0 COMMENT '角色类型，默认0，普通角色0，普通管理员1' AFTER `rolename`;";
	executeSql( $sql_1 );
	$msg = '更新数据完成，正在更新缓存，请勿关闭窗口......';
	$u = $fileName . '?act=updateSuccess';
	redirect( $u, 1, $msg );
}  elseif ( $act == 'updateSuccess' ) {
	Ibos::app()->cache->clear();
	Module::updateConfig();
	$msg = "恭喜。更新完成，请登录后台更新全局缓存";
	redirect( '../index.php?r=dashboard/update/index', 3, $msg );
}

//===================================函数start=================================
/**
 * 执行mysql.sql文件，创建数据表等
 * @param string $sql sql语句
 */
function executeSql( $sql ) {
	$sqls = String::splitSql( $sql );
	$command = Yii::app()->db->createCommand();
	if ( is_array( $sqls ) ) {
		foreach ( $sqls as $sql ) {
			if ( trim( $sql ) != '' ) {
				$command->setText( $sql )->execute();
			}
		}
	} else {
		$command->setText( $sqls )->execute();
	}
	return true;
}

/**
 * 获取url各个参数
 */
function getParams( $url ) {
	$refer_url = parse_url( $url );
	$params = $refer_url['query'];
	$arr = array();
	if ( !empty( $params ) ) {
		$paramsArr = explode( '&', $params );
		foreach ( $paramsArr as $k => $v ) {
			$a = explode( '=', $v );
			$arr[$a[0]] = $a[1];
		}
	}
	return $arr;
}

/**
 * 是否安装某个模块
 */
function getIsInstall( $module ) {
	$rs = Yii::app()->db->createCommand()
			->select( 'module' )
			->from( '{{module}}' )
			->where( "`module` = '{$module}'" )
			->queryScalar();
	return !!$rs;
}

/**
 * 判断某个模块是否可用
 */
function getIsEnabled( $module ) {
	$rs = Yii::app()->db->createCommand()
			->select( 'module' )
			->from( '{{module}}' )
			->where( "`disabled` = 0 AND `module` = '{$module}'" )
			->queryScalar();
	return !!$rs;
}

/**
 * URL重定向
 * @param string $url 重定向的URL地址
 * @param integer $time 重定向的等待时间（秒）
 * @param string $msg 重定向前的提示信息
 * @return void
 */
function redirect( $url, $time = 0, $msg = '' ) {
	//多行URL地址支持
	$url = str_replace( array( "\n", "\r" ), '', $url );
	if ( empty( $msg ) )
		$msg = "系统将在{$time}秒之后自动跳转到{$url}！";
	if ( !headers_sent() ) {
		// redirect
		if ( 0 === $time ) {
			header( 'Location: ' . $url );
		} else {
			header( "refresh:{$time};url={$url}" );
			Env::iExit( $msg );
		}
	} else {
		$str = "<meta http-equiv='Refresh' content='{$time};URL={$url}'>";
		if ( $time != 0 )
			$str .= $msg;
		Env::iExit( $str );
	}
}
